#!/bin/bash

# Make results directory as needed
results_path="results/q1"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/bodytrack.test.bin"

if [ -f "$trace_path" ]; then
    echo "Trace file found."
else
    echo "Trace file not found. Please add '$trace_path'."
    exit
fi

# Tests for MSI_Upgr with increasing cache block size on a heavily shared workload
./simulate_cache 128k 64 4 msiupgr lru $trace_path > $results_path/msi_upgr_128k.txt
./simulate_cache 256k 64 4 msiupgr lru $trace_path > $results_path/msi_upgr_256k.txt
./simulate_cache 512k 64 4 msiupgr lru $trace_path > $results_path/msi_upgr_512k.txt
./simulate_cache 1024k 64 4 msiupgr lru $trace_path > $results_path/msi_upgr_1024k.txt
./simulate_cache 2048k 64 4 msiupgr lru $trace_path > $results_path/msi_upgr_2048k.txt
