#!/bin/bash

# Make results directory as needed
results_path="results/q3"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/fluidanimate.simdev.bin"

if [ -f "$trace_path" ]; then
    echo "Trace file found."
else
    echo "Trace file not found. Please add '$trace_path'."
    exit
fi

# Tests for Dragon (Write Update Protocol)
./simulate_cache 1024k 64 1 dragon lru $trace_path > $results_path/dragon_1.txt
./simulate_cache 1024k 64 2 dragon lru $trace_path > $results_path/dragon_2.txt
./simulate_cache 1024k 64 4 dragon lru $trace_path > $results_path/dragon_4.txt
./simulate_cache 1024k 64 8 dragon lru $trace_path > $results_path/dragon_8.txt

# Tests for MSI with Bus Upgrade (Write Invalidate Protocol)
./simulate_cache 1024k 64 1 msiupgr lru $trace_path > $results_path/msiupgr_1.txt
./simulate_cache 1024k 64 2 msiupgr lru $trace_path > $results_path/msiupgr_2.txt
./simulate_cache 1024k 64 4 msiupgr lru $trace_path > $results_path/msiupgr_4.txt
./simulate_cache 1024k 64 8 msiupgr lru $trace_path > $results_path/msiupgr_8.txt
