#!/bin/bash

# Make results directory as needed
results_path="results/q4"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/dedup.simdev.bin"

if [ -f "$trace_path" ]; then
    echo "Trace file found."
else
    echo "Trace file not found. Please add '$trace_path'."
    exit
fi

# Associtiavity Tests for Larger Cache
./simulate_cache 1024k 64 1 mosi lru $trace_path > $results_path/mosi_large_1.txt
./simulate_cache 1024k 64 2 mosi lru $trace_path > $results_path/mosi_large_2.txt
./simulate_cache 1024k 64 4 mosi lru $trace_path > $results_path/mosi_large_4.txt
./simulate_cache 1024k 64 8 mosi lru $trace_path > $results_path/mosi_large_8.txt

# Associtiavity Tests for Smaller Cache
./simulate_cache 1024k 64 1 mosi lru $trace_path > $results_path/mosi_small_1.txt
./simulate_cache 1024k 64 2 mosi lru $trace_path > $results_path/mosi_small_2.txt
./simulate_cache 1024k 64 4 mosi lru $trace_path > $results_path/mosi_small_4.txt
./simulate_cache 1024k 64 8 mosi lru $trace_path > $results_path/mosi_small_8.txt
