#!/bin/bash

# Make results directory as needed
results_path="results/test"

if [ ! -d "$results_path" ]; then
  echo "Creating directory structure: $results_path"
  mkdir -p "$results_path"
else
  echo "Directory structure already exists: $results_path"
fi

trace_path="traces/streamcluster.simdev.bin"

if [ -f "$trace_path" ]; then
    echo "Trace file found."
else
    echo "Trace file not found. Please add '$trace_path'."
    exit
fi

# A few tests with the shorter test trace (Note: trace files must be in the traces folder)
./simulate_cache 1024k 32 4 msiupgr lru traces/streamcluster.simdev.bin > results/test/msi_upgr_32.txt
./simulate_cache 1024k 64 4 msiupgr lru traces/streamcluster.simdev.bin > results/test/msi_upgr_64.txt
./simulate_cache 1024k 128 4 msiupgr lru traces/streamcluster.simdev.bin > results/test/msi_upgr_128.txt

echo "Differences for msi_upgr_32"
diff results/test/msi_upgr_32.txt results/reference/msi_upgr_32.txt
echo ""

echo "Differences for msi_upgr_64"
diff results/test/msi_upgr_64.txt results/reference/msi_upgr_64.txt
echo ""

echo "Differences for msi_upgr_128"
diff results/test/msi_upgr_128.txt results/reference/msi_upgr_128.txt
echo ""
